import java.io.*;
import java.util.Scanner;
import java.awt.event.*;
import java.text.*;
import javax.swing.*;

public class TestStage3
{
  public static void main(String[ ] args)
  {
    SemaforoDeGiro semg = new SemaforoDeGiro(5,4);
    DetectorDeRequerimiento sensor = new DetectorDeRequerimiento();
    Controlador control = new Controlador(sensor , semg);
    SimuladorEntradas simu = new SimuladorEntradas(sensor, args[0]);
    simu.start(sensor);
    control.manageTraffic();
  }
}

class DetectorDeRequerimiento
{

  public boolean isOn()
  {
    return encendido;
  }

  public void setOn()
  {
    encendido = true;
  }

  public void setOff()
  {
    encendido = false;
  }

  public String toString()
  {
    if (encendido == true)
      return "1";
    else
      return "0";
  }

  private boolean encendido;
}

class SemaforoDeGiro
{
  public SemaforoDeGiro(int greenTime, int blinkingTime)
  {
    tiempo_verde = greenTime;
    tiempo_parpadeo = blinkingTime;
  }


  public void turnGreenLightOn()
  {
    verde = true;
  }

  public void turnGreenLightOff()
  {
    verde = false;
  }

  public int getGreenLightTime()
  {
    return tiempo_verde;
  }

  public int getBlinkingTime()
  {
    return tiempo_parpadeo;
  }

  public String toString()
  {
    if (verde == true)
      return "1";
    else
      return "0";
  }

  private int tiempo_verde;
  private int tiempo_parpadeo;
  private boolean verde;
}

class Controlador extends Thread
{
	public Controlador(DetectorDeRequerimiento sensorInductivo, SemaforoDeGiro semg)
	{
       sensor = sensorInductivo;
       sema_giro = semg;
       tiempoverde = sema_giro.getGreenLightTime();
       tiempo_parpadeo = sema_giro.getBlinkingTime();
	}
	public void manageTraffic()
	{
		boolean isOn = false;
		int tiempo = 0;
		//Delay para sincronizar con el delay del boton.
		try
		{
			Thread.sleep(1000);
		}
		catch(InterruptedException e)
		{
			System.out.println(e);
		}
		while(true)
		{
			isOn = sensor.isOn();
			if (isOn)
			{
				sema_giro.turnGreenLightOn();
				int conta = 0;
				while(conta < tiempoverde-1)
				{
					System.out.println(tiempo + "  " + sema_giro);
					try
					{
						Thread.sleep(1000);
					}
					catch(InterruptedException e)
					{
						System.out.println(e);
					}
					tiempo++;
					conta++;
				}
				System.out.println(tiempo + "  " + sema_giro);
				int contador = 0;
				int c = 0;
				while(true)
				{
					if (contador < tiempo_parpadeo)
					{
						if (c%2!=0)
						{
							sema_giro.turnGreenLightOff();
							try
							{
								Thread.sleep(250);
							}
							catch(InterruptedException e)
							{
								System.out.println(e);
							}
						}
						else
						{
							sema_giro.turnGreenLightOn();
							try
							{
								Thread.sleep(250);
							}
							catch(InterruptedException e)
							{
								System.out.println(e);
							}
						}
						c++;
						if (c%4==0)
						{
							tiempo++;
							contador++;
							System.out.println(tiempo + "  " + sema_giro);
						}
					}
					else
					{
						break;
					}
				}
			sensor.setOff();
			}
			else
			{
				sema_giro.turnGreenLightOff();
				System.out.println(tiempo + "  " + sema_giro);
			};
			try
			{
				Thread.sleep(1000);
			}
			catch(InterruptedException e)
			{
				System.out.println(e);
			}
			tiempo++;
		}
	}
  private int tiempo_parpadeo;
  private int tiempoverde;
  private DetectorDeRequerimiento sensor;
  private SemaforoDeGiro sema_giro;
}

class SimuladorEntradas
{
	public SimuladorEntradas(DetectorDeRequerimiento boton, String filename)
	{
    try
    {
  		temporal = new File (filename);
  		archivo = new Scanner (temporal);
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
	}
	public void start(DetectorDeRequerimiento boton)
	{
		class Leer implements ActionListener
		{
        public Leer(DetectorDeRequerimiento button)
      {
        boton=button;
      }
			public void actionPerformed(ActionEvent event)
			{
          if (archivo.hasNext())
          {
            String linea = archivo.nextLine();
    				if (linea.equals("1"))
    				{
    					boton.setOn();
    				}
          }
  				else
  				{
  					System.exit(0);
  				}
			}
      private DetectorDeRequerimiento boton;
		}
   ActionListener lectura = new Leer(boton);
   Timer t = new Timer(1000, lectura);
   t.start();
	}
	private File temporal;
  private Scanner archivo;
}
