import java.io.*;
import java.util.Scanner;
import java.awt.event.*;
import java.text.*;
import javax.swing.*;

class TestStage4
{
	public static void main(String[ ] args)
	{
		SemaforoP semp_1 = new SemaforoP(4,3); //PP
    SemaforoP semp_2 = new SemaforoP(4,3);//PM
    SemaforoDeGiro sema_giro = new SemaforoDeGiro(4,3); //G
    Semaforo3 semaforo_1 = new Semaforo3(10); //M
    Semaforo3 semaforo_2 = new Semaforo3(10); //PVA
    Semaforo3 semaforo_3 = new Semaforo3(10); //PVI
    DetectorDeRequerimiento boton_1 = new DetectorDeRequerimiento();//BP
    DetectorDeRequerimiento boton_2 = new DetectorDeRequerimiento();//BM
    DetectorDeRequerimiento sensor = new DetectorDeRequerimiento(); //SI
    Controlador control = new Controlador(sensor, boton_1, boton_2, semp_1, semp_2,  semaforo_1, semaforo_2, semaforo_3, sema_giro);
    SimuladorEntradas simu = new SimuladorEntradas(boton_1, boton_2, sensor, args[0]);
    simu.start();
    Imprimir impri = new Imprimir (semp_1, semp_2, sema_giro, semaforo_2, semaforo_3, semaforo_1);
    impri.start();
    control.manageTraffic();
	}
}

class DetectorDeRequerimiento
{
	public boolean isOn()
	{
		return encendido;
	}

	public void setOn()
	{
		encendido = true;
	}

	public void setOff()
	{
		encendido = false;
	}

	public String toString()
	{
		if (encendido == true)
			return "1";
		else
			return "0";
	}

	private boolean encendido;
}

class Semaforo3
{
	public Semaforo3(int greenTime) // Se inicializa el semaforo en verde
	{
		tiempo_verde = greenTime;
		rojo = false;
		amarillo = false;
		verde = true;
	}
	public void turnRedLightOn()
	{
		rojo = true;
		amarillo = false;
		verde = false;
	}
	public void turnYellowLightOn()
	{
		rojo = false;
		amarillo = true;
		verde = false;
	}
	public void turnGreenLightOn()
	{
		rojo = false;
		amarillo = false;
		verde = true;
	}
	public int getGreenTime()
	{
		return tiempo_verde;
	}
	public static int getYellowLightTime()
	{
		return 3;
	}
	public String toString()
	{
		if (rojo == true)
			return "0";
		else if (amarillo == true)
			return "1";
		else
			return "2";
	}
	private boolean rojo;
	private boolean verde;
	private boolean amarillo;
	private int tiempo_verde;
}

class SemaforoP
{
	public SemaforoP(int greenTime, int blinkingTime)
	{
		tiempo_verde = greenTime;
		tiempo_parpadeo = blinkingTime;
		rojo = true;
	}

	public void turnRedLightOn()
	{
		rojo = true;
	}

	public void turnGreenLightOn()
	{
		rojo = false;
		verde = true;
	}

	public void turnGreenLightOff()
	{
		verde = false;
	}

	public int getGreenLightTime()
	{
		return tiempo_verde;
	}

	public int getBlinkingTime()
	{
		return tiempo_parpadeo;
	}

	public String toString()
	{
		if (rojo == true)
			return "0";
		else
			return "1";
	}
	private int tiempo_verde;
	private int tiempo_parpadeo;
	private boolean rojo;
	private boolean verde;
}

class SemaforoDeGiro
{
  public SemaforoDeGiro(int greenTime, int blinkingTime)
  {
    tiempo_verde = greenTime;
    tiempo_parpadeo = blinkingTime;
  }

  public void turnGreenLightOn()
  {
    verde = true;
  }

  public void turnGreenLightOff()
  {
    verde = false;
  }

  public int getGreenLightTime()
  {
    return tiempo_verde;
  }

  public int getBlinkingTime()
  {
    return tiempo_parpadeo;
  }

  public String toString()
  {
    if (verde == true)
      return "1";
    else
      return "0";
  }

  private int tiempo_verde;
  private int tiempo_parpadeo;
  private boolean verde;
}

class Controlador
{
  public Controlador(DetectorDeRequerimiento SI1, DetectorDeRequerimiento BP1, DetectorDeRequerimiento BM1 , SemaforoP PP1 , SemaforoP PM1, Semaforo3 M1, Semaforo3 PVA1, Semaforo3 PVI1, SemaforoDeGiro G1)
  {
  SI = SI1;
  BP = BP1;
  BM = BM1;
  PP = PP1;
  PM = PM1;
  M = M1;
  PVA = PVA1;
  PVI = PVI1;
  G = G1;
	tiempoverdePP = PP.getGreenLightTime();
	tiempoparpadeoPP = PP.getBlinkingTime(); 
	tiempoverdePM = PM.getGreenLightTime();
	tiempoparpadeoPM = PM.getBlinkingTime();
	tiempoverdeM = M.getGreenTime();
	tiempoamarilloM = M.getYellowLightTime();
	tiempoverdePVA = PVA.getGreenTime();
	tiempoamarilloPVA = PVA.getYellowLightTime();
	tiempoverdePVI = PVI.getGreenTime();
	tiempoamarilloPVI = PVI.getYellowLightTime();
	tiempoverdeG = G.getGreenLightTime();
	tiempoparpadeoG = G.getBlinkingTime();
	
  }


  public void manageTraffic()
  {
	long startTime = System.currentTimeMillis();
    long endtime = 0;
    boolean isOnSI = false;
	boolean isOnBP = false;
	boolean isOnBM = false;
    long Tiempoini = System.currentTimeMillis();
    long Tiempoactual = System.currentTimeMillis();
	long tiempooff = 0;
	int c = 0;
	long tiempoini = System.currentTimeMillis();

	///////////////////////////////////////////////////////////////
	/////////////// Estado Inicial del sistema /////////////////////
	///////////////////////////////////////////////////////////////
	PVI.turnGreenLightOn();
	PVA.turnGreenLightOn();
	M.turnRedLightOn();
	PP.turnRedLightOn();
	PM.turnRedLightOn();
	G.turnGreenLightOff();
	
	long TiempoSecuencia = System.currentTimeMillis(); //Utilizado para contar cuanto tiempo lleva en el mismo estado el semaforo
	while(true){
		endtime = System.currentTimeMillis();
		if (endtime - startTime > 1000){
			//estado de botones y sensor
			isOnBP = BP.isOn();
			isOnBM = BM.isOn();
			isOnSI = SI.isOn();
			
			///////////////////////////////////////////
			/////////Opciones en secuencia ////////////
			///////////////////////////////////////////
			Tiempoactual = System.currentTimeMillis();  
			if ( (PVI.toString() == "2") && (PVA.toString() == "2") && (M.toString() == "0") && (isOnSI) && (tiempoverdeG + tiempoparpadeoG < tiempoverdePVA-((Tiempoactual-TiempoSecuencia)/1000) ))
			{
				PVI.turnYellowLightOn();
				PVA.turnGreenLightOn();
				M.turnRedLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
				try{Thread.sleep(tiempoamarilloPVI*1000);}catch(InterruptedException e){System.out.println(e);}
				
				PVI.turnRedLightOn();
				PVA.turnGreenLightOn();
				M.turnRedLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOn();
				
				try{Thread.sleep(tiempoverdeG*1000);}catch(InterruptedException e){System.out.println(e);}
				
				tiempooff = 0;
				c = 0;
				tiempoini = System.currentTimeMillis();
				while(true)
				{
					if ((tiempooff-tiempoini) < (tiempoparpadeoG*1000))
					{
						if (c%2!=0)
						{
							G.turnGreenLightOff();
							try{Thread.sleep(250);}catch(InterruptedException e){System.out.println(e);}
						}
						else 
						{
							G.turnGreenLightOn();
							try{Thread.sleep(250);}catch(InterruptedException e){System.out.println(e);}
						}
						c = c + 1;
						tiempooff = System.currentTimeMillis();
					}
					else
					{
						break;
					}
				}
				G.turnGreenLightOff();
				try{Thread.sleep( (tiempoverdePVA - ((Tiempoactual-TiempoSecuencia)/1000)-tiempoverdeG-tiempoparpadeoG )*1000);}catch(InterruptedException e){System.out.println(e);}
				
				PVI.turnRedLightOn();
				PVA.turnYellowLightOn();
				M.turnRedLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
				try{Thread.sleep(tiempoamarilloPVA*1000);}catch(InterruptedException e){System.out.println(e);}
				
				PVI.turnRedLightOn();
				PVA.turnRedLightOn();
				M.turnGreenLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
        SI.setOff();
				TiempoSecuencia = System.currentTimeMillis();
			}
			else if ( (PVI.toString() == "2") && (PVA.toString() == "2") && (M.toString() == "0") && (isOnBM) && (tiempoverdePM + tiempoparpadeoPM < tiempoverdePVA-((Tiempoactual-TiempoSecuencia)/1000) ))
			{
				PVI.turnGreenLightOn();
				PVA.turnGreenLightOn();
				M.turnRedLightOn();
				PP.turnRedLightOn();
				PM.turnGreenLightOn();
				G.turnGreenLightOff();
				try{Thread.sleep(tiempoverdePM*1000);}catch(InterruptedException e){System.out.println(e);}
				
				tiempooff = 0;
				c = 0;
				tiempoini = System.currentTimeMillis();
				while(true)
				{
					if ((tiempooff-tiempoini) < (tiempoparpadeoPM*1000))
					{
						if (c%2!=0)
						{
							PM.turnGreenLightOff();
							try{Thread.sleep(250);}catch(InterruptedException e){System.out.println(e);}
						}
						else 
						{
							PM.turnGreenLightOn();
							try{Thread.sleep(250);}catch(InterruptedException e){System.out.println(e);}
						}
						c = c + 1;
						tiempooff = System.currentTimeMillis();
					}
					else
					{
						break;
					}
				}
				
				PVI.turnGreenLightOn();
				PVA.turnGreenLightOn();
				M.turnRedLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
				try{Thread.sleep( (tiempoverdePVA - ((Tiempoactual-TiempoSecuencia)/1000)-tiempoverdePM-tiempoparpadeoPM )*1000);}catch(InterruptedException e){System.out.println(e);}
				
				PVI.turnYellowLightOn();
				PVA.turnYellowLightOn();
				M.turnRedLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
				try{Thread.sleep( tiempoamarilloPVA*1000);}catch(InterruptedException e){System.out.println(e);}
				
				PVI.turnRedLightOn();
				PVA.turnRedLightOn();
				M.turnGreenLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
        BM.setOff();
				TiempoSecuencia = System.currentTimeMillis();
			}
			else if ( (PVI.toString() == "2") && (PVA.toString() == "2") && (M.toString() == "0") && (isOnBP) )
			{
				PVI.turnYellowLightOn();
				PVA.turnYellowLightOn();
				M.turnRedLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
				try{Thread.sleep(tiempoamarilloPVA*1000);}catch(InterruptedException e){System.out.println(e);}
				
				PVI.turnRedLightOn();
				PVA.turnRedLightOn();
				M.turnGreenLightOn();
				PP.turnGreenLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
				try{Thread.sleep(tiempoverdePP*1000);}catch(InterruptedException e){System.out.println(e);}
				
				tiempooff = 0;
				c = 0;
				tiempoini = System.currentTimeMillis();
				while(true)
				{
					if ((tiempooff-tiempoini) < (tiempoparpadeoPP*1000))
					{
						if (c%2!=0)
						{
							PP.turnGreenLightOff();
							try{Thread.sleep(250);}catch(InterruptedException e){System.out.println(e);}
						}
						else 
						{
							PP.turnGreenLightOn();
							try{Thread.sleep(250);}catch(InterruptedException e){System.out.println(e);}
						}
						c = c + 1;
						tiempooff = System.currentTimeMillis();
					}
					else
					{
						break;
					}
				}
				PP.turnRedLightOn();
				try{Thread.sleep((tiempoverdeM-tiempoverdePP-tiempoparpadeoPP)*1000);}catch(InterruptedException e){System.out.println(e);}
				
				PVI.turnRedLightOn();
				PVA.turnRedLightOn();
				M.turnYellowLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
				try{Thread.sleep((tiempoamarilloM*1000));}catch(InterruptedException e){System.out.println(e);}
				
				PVI.turnGreenLightOn();
				PVA.turnGreenLightOn();
				M.turnRedLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
        BP.setOff();
				TiempoSecuencia = System.currentTimeMillis();
				
				
			}
			
			else if ((PVI.toString() == "0") && (PVA.toString() == "0") && (M.toString() == "2") && (isOnBM) )
			{
				PVI.turnRedLightOn();
				PVA.turnRedLightOn();
				M.turnYellowLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
				try{Thread.sleep(tiempoamarilloM*1000);}catch(InterruptedException e){System.out.println(e);}
				
				PVI.turnGreenLightOn();
				PVA.turnGreenLightOn();
				M.turnRedLightOn();
				PP.turnRedLightOn();
				PM.turnGreenLightOn();
				G.turnGreenLightOff();
				try{Thread.sleep(tiempoverdePM*1000);}catch(InterruptedException e){System.out.println(e);}
				
				tiempooff = 0;
				c = 0;
				tiempoini = System.currentTimeMillis();
				while(true)
				{
					if ((tiempooff-tiempoini) < (tiempoparpadeoPM*1000))
					{
						if (c%2!=0)
						{
							PM.turnGreenLightOff();
							try{Thread.sleep(250);}catch(InterruptedException e){System.out.println(e);}
						}
						else 
						{
							PM.turnGreenLightOn();
							try{Thread.sleep(250);}catch(InterruptedException e){System.out.println(e);}
						}
						c = c + 1;
						tiempooff = System.currentTimeMillis();
					}
					else
					{
						break;
					}
				}
				PM.turnRedLightOn();
				try{Thread.sleep(tiempoverdePVA-tiempoverdePM-tiempoparpadeoPM);}catch(InterruptedException e){System.out.println(e);}
				
				PVI.turnYellowLightOn();
				PVA.turnYellowLightOn();
				M.turnRedLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
				try{Thread.sleep(tiempoamarilloPVA*1000);}catch(InterruptedException e){System.out.println(e);}
				
				PVI.turnRedLightOn();
				PVA.turnRedLightOn();
				M.turnGreenLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
        BM.setOff();
				TiempoSecuencia = System.currentTimeMillis();
				
				
			}
			
			else if ( (PVI.toString() == "0") && (PVA.toString() == "0") && (M.toString() == "2") && (isOnBP) && (tiempoverdePP + tiempoparpadeoPP < tiempoverdeM-((Tiempoactual-TiempoSecuencia)/1000) ))
			{
				PVI.turnRedLightOn();
				PVA.turnRedLightOn();
				M.turnGreenLightOn();
				PP.turnGreenLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
				try{Thread.sleep(tiempoverdePP*1000);}catch(InterruptedException e){System.out.println(e);}
				
				
				tiempooff = 0;
				c = 0;
				tiempoini = System.currentTimeMillis();
				while(true)
				{
					if ((tiempooff-tiempoini) < (tiempoparpadeoPP*1000))
					{
						if (c%2!=0)
						{
							PP.turnGreenLightOff();
							try{Thread.sleep(250);}catch(InterruptedException e){System.out.println(e);}
						}
						else 
						{
							PP.turnGreenLightOn();
							try{Thread.sleep(250);}catch(InterruptedException e){System.out.println(e);}
						}
						c = c + 1;
						tiempooff = System.currentTimeMillis();
					}
					else
					{
						break;
					}
				}
				
				PVI.turnRedLightOn();
				PVA.turnRedLightOn();
				M.turnGreenLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
				try{Thread.sleep( (tiempoverdeM - ((Tiempoactual-TiempoSecuencia)/1000)-tiempoverdePP-tiempoparpadeoPP )*1000);}catch(InterruptedException e){System.out.println(e);}
				
				PVI.turnRedLightOn();
				PVA.turnRedLightOn();
				M.turnYellowLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
				try{Thread.sleep(tiempoamarilloM*1000);}catch(InterruptedException e){System.out.println(e);}
				
				PVI.turnGreenLightOn();
				PVA.turnGreenLightOn();
				M.turnRedLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
        BP.setOff();
				TiempoSecuencia = System.currentTimeMillis();
				
				
			}
			
			else if ( (PVI.toString() == "0") && (PVA.toString() == "0") && (M.toString() == "2") && (Tiempoactual-TiempoSecuencia > (tiempoverdeM*1000)) )
			{
				PVI.turnRedLightOn();
				PVA.turnRedLightOn();
				M.turnYellowLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
				try{Thread.sleep(tiempoamarilloM*1000);}catch(InterruptedException e){System.out.println(e);}
				
				PVI.turnGreenLightOn();
				PVA.turnGreenLightOn();
				M.turnRedLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
				TiempoSecuencia = System.currentTimeMillis();
				

			}
			
			else if ((PVI.toString() == "2") && (PVA.toString() == "2") && (M.toString() == "0") && (Tiempoactual-TiempoSecuencia > (tiempoverdePVI*1000)) )
			{
				PVI.turnYellowLightOn();
				PVA.turnYellowLightOn();
				M.turnRedLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
				try{Thread.sleep(tiempoamarilloPVI*1000);}catch(InterruptedException e){System.out.println(e);}
				
				PVI.turnRedLightOn();
				PVA.turnRedLightOn();
				M.turnGreenLightOn();
				PP.turnRedLightOn();
				PM.turnRedLightOn();
				G.turnGreenLightOff();
				TiempoSecuencia = System.currentTimeMillis();
				
			}
			startTime = System.currentTimeMillis();
		}
		try{Thread.sleep(50);}catch(InterruptedException e){System.out.println(e);}
	}
  }
	private int tiempoverdePP;
	private int tiempoparpadeoPP; 
	private int tiempoverdePM ;
	private int tiempoparpadeoPM; 
	private int tiempoverdeM ;
	private int tiempoamarilloM; 
	private int tiempoverdePVA;
	private int tiempoamarilloPVA; 
	private int tiempoverdePVI;
	private int tiempoamarilloPVI; 
	private int tiempoverdeG ;
	private int tiempoparpadeoG; 
	private DetectorDeRequerimiento SI;
	private DetectorDeRequerimiento BP;
	private DetectorDeRequerimiento BM;
	private SemaforoP PP;
	private SemaforoP PM;
	private Semaforo3 M;
	private Semaforo3 PVA;
	private Semaforo3 PVI;
	private SemaforoDeGiro G;
}

class SimuladorEntradas
{  
	public SimuladorEntradas(DetectorDeRequerimiento boton_p, DetectorDeRequerimiento boton_m, DetectorDeRequerimiento sensor, String filename)
	{
		try
		{
			temporal = new File (filename);
			archivo = new Scanner (temporal);
			boton_placeres = boton_p;
			boton_matta = boton_m;
			sensor_inductivo = sensor;
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
	}	
	public void start()  
	{
		class Leer implements ActionListener 
		{
			public Leer()
			{
			
			}
			public void actionPerformed(ActionEvent event)
			{
				if (archivo.hasNext())
				{
					String linea = archivo.nextLine();
					String[] valores = linea.split("\t"); 
					if (valores[0].equals("1"))
					{
						boton_placeres.setOn();
					}
					if (valores[1].equals("1"))
					{
						boton_matta.setOn();
					}
					if (valores[2].equals("1"))
					{
						sensor_inductivo.setOn();
					}
				}
				else 
				{
				System.exit(0);
				}
			}
		}
	ActionListener lectura = new Leer();
	Timer t = new Timer(1000, lectura);
	t.start();
	}
	private DetectorDeRequerimiento boton_placeres;
	private DetectorDeRequerimiento boton_matta;
	private DetectorDeRequerimiento sensor_inductivo;
	private File temporal;
	private Scanner archivo;
}
// La siguiente clase fue creada para iprimir de forma paralela los estados de los semaforos
class Imprimir
{  
	public Imprimir(SemaforoP placeres, SemaforoP matta, SemaforoDeGiro giro, Semaforo3 Placeres_Valp, Semaforo3 Placeres_Vina, Semaforo3 bajando_matta)
	{
		P = placeres;
		M = matta;
		G = giro;
		P_Valp = Placeres_Valp;
		P_Vina = Placeres_Vina;
		b_matta = bajando_matta;
		time = 0;
	}	
	public void start()  
	{
		class Impresion implements ActionListener 
		{
			public Impresion()
			{
			
			}
			public void actionPerformed(ActionEvent event)
			{
				System.out.println( time + "  "+ P.toString() + "  " + M.toString() + "  " + G.toString() + "  " + P_Valp.toString() + "  "+ P_Vina.toString() +"  "+ b_matta.toString());
				time++;
			}
		}
	ActionListener imp = new Impresion();
	Timer t = new Timer(1000, imp);
	t.start();
	}
	private SemaforoP P;
	private SemaforoP M;
	private SemaforoDeGiro G;
	private Semaforo3 P_Valp;
	private Semaforo3 P_Vina;
	private Semaforo3 b_matta;
	private int time;
}